# Testitiedotteet

Tähän tietovarantoon voi lisätä tiedotteita tiedotejärjestelmän testaamista
varten. Tiedotetiedoston voi lisätä mihin tahansa hakemistoon millä tahansa
nimellä, mutta sen tulee olla muotoiltu
[markdownina](https://commonmark.org/help/) (tosin siinä voi käyttää
[pandocin](https://pandoc.org/MANUAL.html#pandocs-markdown)
oletuslaajennuksia). Markdown-tiedostot päättyvät yleensä `.md`, joten
tiedotetiedostoille kannattaa käyttää samaa päätettä.

Tiedotetiedoston tulee alkaa metadatalohkolla, joka määrittää mm. lähetysajan,
tiedotteen otsikon ja muotoilun tarkistajan. Metadatalohko alkaa ja päättyy
kolmeen tavuviivaan (`-`) eikä sen sisällä saa olla tyhjiä rivejä. Esimerkiksi:

```yaml
---
otsikko: OMS-testitiedote 1
deadline: 2023-08-06T00:00:00+03:00
lähetysaika: 2023-08-07T10:00:00+03:00
tarkistaja: saku.laesvuori@mail.olarinmaensamoojat.fi
---
```

Aikaleimat `deadline` ja `lähetysaika` on muotoiltava tarkasti tässä muodossa,
eli `YYYY-MM-DDTHH:MM:SSAIKAERO`. Numeroiden määrän on täsmättävä, eli alussa
olevia nollia ei voi jättää pois (esim. `2023-8-6T10:00:00+3:00` olisi väärin).
Aikaero on annetun ajan vyöhykkeen ero UTC:hen, eli Suomessa kesäaikaan
`+03:00` ja talviaikaan `+02:00`.

Tarkistajia voi olla useampia, jolloin ne merkataan omille riveilleen ja rivit
aloitetaan tavuviivalla. Esimerkiksi:

```yaml
tarkistaja:
- saku.laesvuori@mail.olarinmaensamoojat.fi
- saku@laesvuori.fi
```

Kun deadline on ylittynyt, tiedotteesta lähetetään esikatseluversio
sähköpostilla kaikille sen tarkistajille. Tarkistajat lukevat tiedotteen läpi
ja tekevät tarvittaessa viimeiset muutokset. Deadlinen jälkeen tehdyistä
muutoksista lähtee heti uusi esikatselu. Kun tiedote on valmis, tarkistaja
vastaa esikatseluviestiin sähköpostilla, jossa on vastaanottajien
sähköpostiosoitteet. Jokaisen sähköpostiosoitteen pitää olla yksin omalla
rivillään normaalissa tekstissä. Mikäli et ole varma, lähettääkö
sähköpostiohjelmasi viestit raakatekstinä vai HTML:nä, kannattaa sähköpostit
laittaa viestiin tekstitiedostoliitteessä (`.txt`, wordin yms. dokumentit eivät
ole tekstitiedostoja). Vastaanottajien lähettämisen jälkeen tiedote lähtee
kaikille vastaanottajille *lähetysaikaan*. Vastaanottajat täytyy lähettää
vastauksena uusimpaan esikatseluun; vanhempaan versioon vastaaminen ei tee
mitään. Aiemmin lähetetyt vastaanottajat nollaantuvat, jos tiedotteeseen
tehdään muutoksia ja siitä lähetetään uusi esikatselu. Tällöin vastaanottajat
täytyy lähettää uudestaan vastauksena uuteen esikatseluun.

Jos tiedoteen *lähetysaika* ohittuu ilman, että sille on määritetty
vastaanottajia, se vanhenee eikä siitä tule esikatseluita eikä sitä voi
lähettää ennen kuin sen *lähetysaika* on uudelleen siirretty tulevaisuuteen.

Esimerkki kokonaisesta tiedotteesta löytyy tiedostosta
[esimerkkitiedote.md](esimerkkitiedote.md).

Mikäli järjestelmän toiminnasta jää kysyttävää, voi siitä kysyä Sakulta.
